//+------------------------------------------------------------------+
//|                                                XYtoTimePrice.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <XYtoTimePrice.mqh>                                     |
//+------------------------------------------------------------------+
class CXYtoTimePrice
  {
   long              chid;
   datetime          temp[];//    
   int               fvb;//         
   int               hip;//     
   int               Wscale;//      
   double            hib;//    
   double            max;//    
   double            min;//     
   double            Hscale;//   
   string            symbol;
   ENUM_TIMEFRAMES   period;
   datetime          TimeBars(int bar);
public:
   int               barclick;
   datetime          timeclick;
   double            priceclick;
   int               Xclick;
   int               Yclick;
                     CXYtoTimePrice(void){};
                    ~CXYtoTimePrice(void){};
   void              Calc(long chid_);
   void              Calc();
   void              XY_to_TimePrice(int X,int Y);
   void              TimePrice_to_XY(datetime time,double price){};//    
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CXYtoTimePrice::Calc(long chid_)
  {
   chid=chid_;
   symbol=ChartSymbol(chid);
   period=ChartPeriod(chid);
   Calc();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CXYtoTimePrice::Calc()
  {
   fvb=(int)ChartGetInteger(chid,CHART_FIRST_VISIBLE_BAR);
   hip=(int)ChartGetInteger(chid,CHART_HEIGHT_IN_PIXELS);
   max=ChartGetDouble(chid,CHART_PRICE_MAX);
   min=ChartGetDouble(chid,CHART_PRICE_MIN);
   hib=max-min;
   Wscale=(int)pow(2.,ChartGetInteger(chid,CHART_SCALE));
   Hscale=hib/hip;
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+  
datetime CXYtoTimePrice::TimeBars(int bar)
  {
   if(bar>=0)
     {
      CopyTime(symbol,period,bar,1,temp);
      return(temp[0]);
     }
   else
     {
      CopyTime(symbol,period,0,1,temp);
      return(temp[0]-PeriodSeconds(period)*bar);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CXYtoTimePrice::XY_to_TimePrice(int X,int Y)
  {
   barclick=fvb-X/Wscale;
   timeclick=TimeBars(barclick);
   priceclick=max-(Y-4)*Hscale;// 4 -    (   maxprice   4 )
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
